> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rated.network/llms.txt
> Use this file to discover all available pages before exploring further.

# Single validator effectiveness

This endpoint returns all the useful information you need on the historical performance of a single validator. This includes voting effectiveness, proposer effectiveness, missed blocks (i.e. skip rate), etc. For a glossary of the variables returned, see [validators](/rated-api/glossary/solana/validators).

Here's how to interpret the inputs required to operate it👇

| Parameter     | Description                                                                                                         |
| :------------ | :------------------------------------------------------------------------------------------------------------------ |
| `from`        | Starting UTC date (e.g. from="2024-04-22"), or a slot multiple of 3,000 (approximately 20 minutes)                  |
| `granularity` | The size of time increments you are looking to query. Can be `day`or `3k`(3,000 slots or approximately 20 minutes). |
| `size`        | The number of results included per page                                                                             |


## OpenAPI

````yaml get /v0/solana/validators/{validator_id}/performance
openapi: 3.1.0
info:
  title: Rated API
  description: >

    Welcome to Rated API Swagger doc for developers! This doc outlines the Rated
    API functionality and API architecture.


    V0: It is separated into seven categories:


    -   **Validators**: Endpoints to query into individual validator indices or
    aggregations of validator indices.

    -   **Operators**: Endpoints to query into pre-materialized operator
    groupings.

    -   **Network**: Endpoints to query into network aggregate stats.

    -   **Slashings**: Endpoints to query into network aggregate stats.

    -   **Withdrawals (beta)**: Endpoints to query into when a withdrawal is
    expected to land.

    -   **Self Report (beta)**: Endpoint to query into all slashed validators
    and individual slashed validator indices


    V1: It is separated into six categories:

    -   **Overview**: Endpoints encapsulating the current status of operators,
    pools and validators.

    -   **Performance**: Endpoints that dive into performance and effectiveness
    metrics on execution and consensus layer for operators, pools and
    validators.

    -   **Rewards**: Endpoints that dive into relevant metrics around rewards
    and penalties for operators, pools and validators.

    -   **Private Sets**: Endpoints that aggregate custom group of validators
    privately for performance and reward drill downs.

    -   **Metadata**: Endpoints that provide metadata about mappings, slashings
    and APRs for validators, pools and operators.

    -   **Network**: Endpoints that provide network level metrics about
    performance, rewards, and distributions.


    [Terms of Use](https://docs.rated.network/legal/terms/api-terms-of-service)


    [API
    Reference](https://docs.rated.network/rated-api/api-reference/introduction)
  version: '1.0'
servers: []
security: []
paths:
  /v0/solana/validators/{validator_id}/performance:
    get:
      tags:
        - Solana Validators
      summary: Validator Performance
      operationId: >-
        validator_performance_v0_solana_validators__validator_id__performance_get
      parameters:
        - name: validator_id
          in: path
          required: true
          schema:
            type: string
            title: Validator Id
        - name: from
          in: query
          required: false
          schema:
            anyOf:
              - {}
              - type: 'null'
            description: UTC day or slot multiple of 3k
            title: From
          description: UTC day or slot multiple of 3k
        - name: granularity
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/networks__solana__granularity__Granularity'
            description: UTC day or 3k block interval
          description: UTC day or 3k block interval
        - name: size
          in: query
          required: false
          schema:
            type: integer
            maximum: 200
            minimum: 1
            default: 15
            title: Size
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/PaginatedResponse_SolanaValidatorPerformance_
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
      security:
        - HTTPBearer: []
components:
  schemas:
    networks__solana__granularity__Granularity:
      type: string
      enum:
        - 3k
        - day
      title: Granularity
    PaginatedResponse_SolanaValidatorPerformance_:
      properties:
        page:
          $ref: '#/components/schemas/api__schemas__page_solana__Page'
        total:
          type: integer
          minimum: 0
          title: Total
        data:
          items:
            $ref: '#/components/schemas/SolanaValidatorPerformance'
          type: array
          title: Data
        next:
          anyOf:
            - type: string
            - type: 'null'
          title: Next
      type: object
      required:
        - page
        - total
        - data
      title: PaginatedResponse[SolanaValidatorPerformance]
    ErrorResponse:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Error'
          type: array
          title: Detail
      type: object
      required:
        - detail
      title: ErrorResponse
    api__schemas__page_solana__Page:
      properties:
        from:
          anyOf:
            - type: integer
            - type: string
              format: date
            - type: 'null'
          title: From
        to:
          anyOf:
            - type: integer
            - type: string
              format: date
            - type: 'null'
          title: To
        granularity:
          anyOf:
            - $ref: '#/components/schemas/networks__solana__granularity__Granularity'
            - type: 'null'
        size:
          anyOf:
            - type: integer
              exclusiveMinimum: 0
            - type: 'null'
          title: Size
      type: object
      title: Page
    SolanaValidatorPerformance:
      properties:
        voteAccount:
          type: string
          title: Voteaccount
        from:
          title: From
        skippedSlots:
          type: integer
          minimum: 0
          title: Skippedslots
        voteLatency:
          type: string
          title: Votelatency
        uptime:
          type: string
          title: Uptime
        effectiveness:
          type: string
          title: Effectiveness
        proposedSlots:
          type: integer
          minimum: 0
          title: Proposedslots
        voteOnlySlots:
          type: integer
          minimum: 0
          title: Voteonlyslots
        totalVotes:
          type: integer
          minimum: 0
          title: Totalvotes
        sumLatency:
          type: integer
          minimum: 0
          title: Sumlatency
        voteDutiesCount:
          type: integer
          minimum: 0
          title: Votedutiescount
        totalVoteScore:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Totalvotescore
        delinquencies:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Delinquencies
      type: object
      required:
        - voteAccount
        - from
        - skippedSlots
        - voteLatency
        - uptime
        - effectiveness
        - proposedSlots
        - voteOnlySlots
        - totalVotes
        - sumLatency
        - voteDutiesCount
      title: SolanaValidatorPerformance
      examples:
        - delinquencies: 2
          effectiveness: 0.965
          from_: '2024-12-14'
          proposedSlots: 90
          skippedSlots: 5
          sumLatency: 45000
          totalVoteScore: 480000
          totalVotes: 30000
          uptime: 0.95
          voteAccount: voteAccount
          voteDutiesCount: 31578
          voteLatency: 1.5
          voteOnlySlots: 10
    Error:
      properties:
        loc:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Loc
        msg:
          type: string
          title: Msg
        type:
          type: string
          title: Type
      type: object
      required:
        - msg
        - type
      title: Error
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````